<script lang="ts">
import Vue from 'vue';
import { ImageUrlMixin } from '~/mixins';

import {
  SlpBreadcrumb,
  SlpHorizontalRule,
} from '~/components/common/index.vue';

export default Vue.extend({
  name: 'CaseStudyHero',
  components: {
    SlpBreadcrumb,
    SlpHorizontalRule,
  },
  mixins: [ImageUrlMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    baseData: {
      type: Object,
      required: true,
      default: null,
    },
  },
  computed: {
    crumbs() {
      return [
        this.baseData.crumbs,
        {
          title: this.data.companyName,
        },
      ];
    },
  },
});
</script>

<template>
  <section>
    <div class="gradient" />
    <SlpContainer>
      <SlpBreadcrumb class="slp-mt-32" :crumbs="crumbs" />
      <div class="slp-mt-48 logos">
        <template v-if="data.companyLogo">
          <img
            :src="parseImageUrl(data.companyLogo.fields.file.url, 1022, 490)"
            loading="lazy"
            alt=""
          />
          <span>+</span>
        </template>
        <img :src="baseData.gitlab_logo" />
      </div>
      <SlpTypography class="slp-mt-48" variant="heading1-bold" tag="h1">{{
        data.heading
      }}</SlpTypography>
      <div class="key-benefits">
        <div
          v-for="benefit in data.keyBenefits.benefits"
          :key="benefit.label"
          class="key-benefit"
        >
          <nuxt-img
            v-if="benefit.logo_src"
            :src="benefit.logo_src"
            width="32"
            height="32"
            format="webp"
            quality="99"
          />
          <SlpIcon
            v-else
            variant="marketing"
            :name="benefit.icon"
            size="md"
            class="key-benefit__icon"
          />
          <SlpTypography
            variant="body1-bold"
            class="key-benefit__label slp-ml-16"
            >{{ benefit.label }}</SlpTypography
          >
        </div>
      </div>
      <img
        class="slp-mt-48 header_image"
        :src="data.headerImage.fields.file.url"
      />

      <div class="facts">
        <div class="fact">
          <SlpTypography variant="body3-bold" class="fact__text">{{
            baseData.industry
          }}</SlpTypography>
          <SlpTypography variant="body2">{{ data.industry }}</SlpTypography>
        </div>
        <div class="fact">
          <SlpTypography variant="body3-bold" class="fact__text">{{
            data.contributors ? baseData.contributors : baseData.employees
          }}</SlpTypography>
          <SlpTypography variant="body2">{{
            data.contributors ? data.contributors : data.employeeCount
          }}</SlpTypography>
        </div>
        <div class="fact">
          <SlpTypography variant="body3-bold" class="fact__text">{{
            baseData.location
          }}</SlpTypography>
          <SlpTypography variant="body2">{{ data.location }}</SlpTypography>
        </div>
        <div class="fact">
          <SlpTypography variant="body3-bold" class="fact__text">{{
            baseData.solution
          }}</SlpTypography>
          <SlpTypography variant="body2">
            <div v-html="$md.render(data.solution)"></div>
          </SlpTypography>
        </div>
        <div class="try_ultimate">
          <SlpTypography variant="body2">
            <div v-html="$md.render(baseData.try_ultimate)"></div>
          </SlpTypography>
          <SlpButton
            class="slp-mt-16"
            variant="primary"
            :href="baseData.try_ultimate_button.href"
            :data-ga-name="baseData.try_ultimate_button.data_ga_name"
            :data-ga-location="baseData.try_ultimate_button.data_ga_location"
          >
            {{ baseData.try_ultimate_button.text }}
          </SlpButton>
        </div>
      </div>

      <SlpHorizontalRule />
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.slp-hr {
  margin-top: $spacing-32 !important;
}

.facts {
  display: flex;
  justify-content: space-between;
  margin-top: $spacing-32;

  .fact {
    display: flex;
    flex-direction: column;

    @media (min-width: $breakpoint-md) {
      max-width: 15rem;
    }

    &__text {
      margin-bottom: 12px;
    }
  }
}

.try_ultimate {
  max-width: 252px;
}

.gradient {
  background: linear-gradient(
    90.05deg,
    #eee7fd 2.53%,
    rgba(246, 243, 254, 0.83) 50.98%,
    rgba(255, 212, 216, 0.45) 100%
  );
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  height: 720px;
  z-index: -1;
}

.logos {
  display: flex;
  align-items: center;

  span {
    display: flex;
    align-items: center;
    margin: 0 16px;
  }
  img {
    max-height: $spacing-32;
    max-width: min(150px, 50vw - 36px);
  }
}

.key-benefits {
  margin-top: $spacing-32;
  display: flex;
  flex-wrap: wrap;
}

.key-benefit {
  display: flex;
  align-items: center;
  flex-basis: 33%;
  margin-bottom: $spacing-16;
}

.header_image {
  width: 100%;
  height: 490px;
  object-fit: cover;
  border-radius: 4px 4px 90px 4px;
}

@media (max-width: $breakpoint-sm) {
  .facts {
    display: block;
    margin-top: $spacing-16;

    .fact {
      flex-direction: row;
      margin-bottom: $spacing-16;

      &__text {
        margin-bottom: 0;
        margin-right: 16px;
      }
    }
  }

  .gradient {
    height: 850px;
  }

  .key-benefits {
    display: block;
  }

  .header_image {
    max-height: 180px;
  }

  .key-benefit {
    margin-left: 0px;

    &:not(:first-child) {
      margin-left: 0px;
      margin-top: $spacing-16;
    }

    &__icon {
      width: 24px;
      height: 24px;
    }

    &__label {
      font-size: 16px;
      line-height: 20px;
    }
  }

  .try_ultimate {
    max-width: none;
  }
}
</style>
